import { AxiosAdapter, AxiosRequestConfig } from 'axios';
import { HttpClient, RequestOptions, HttpResponse, HttpRequest, HttpInterceptor } from '@nbottarini/abstract-http-client';

declare class AxiosHttpClient implements HttpClient {
    private readonly http;
    private readonly baseUrl;
    private readonly responseFactory;
    private interceptors;
    private errorInterceptors;
    constructor(baseUrl?: string | undefined, axiosAdapter?: AxiosAdapter | undefined, axiosConfig?: AxiosRequestConfig);
    get<T = any>(url: string, headers?: Record<string, string>, options?: RequestOptions): Promise<HttpResponse<T>>;
    post<T = any>(url: string, data?: any, headers?: Record<string, string>, options?: RequestOptions): Promise<HttpResponse<T>>;
    put<T = any>(url: string, data?: any, headers?: Record<string, string>, options?: RequestOptions): Promise<HttpResponse<T>>;
    delete<T = any>(url: string, headers?: Record<string, string>, options?: RequestOptions): Promise<HttpResponse<T>>;
    patch<T = any>(url: string, data?: any, headers?: Record<string, string>, options?: RequestOptions): Promise<HttpResponse<T>>;
    head<T = any>(url: string, headers?: Record<string, string>, options?: RequestOptions): Promise<HttpResponse<T>>;
    private request;
    send<T = any>(request: HttpRequest): Promise<HttpResponse<T>>;
    private progressHandler;
    private interceptRequest;
    private interceptResponse;
    addInterceptor(interceptor: HttpInterceptor): void;
    private handleError;
    private createHttpError;
    private createNetworkError;
    private responseBodyConversionToResponseType;
}

export { AxiosHttpClient };
