"use strict";var axios=require("axios"),abstractHttpClient=require("@nbottarini/abstract-http-client");class ResponseFactory{create(axiosResponse,request){const urlHelper=new abstractHttpClient.UrlHelper(axiosResponse.config.baseURL,axiosResponse.config.url);return{method:request.method,status:axiosResponse.status,statusText:axiosResponse.statusText,url:urlHelper.absoluteUrl,headers:axiosResponse.headers,body:axiosResponse.data,request:request}}}exports.AxiosHttpClient=class{http;baseUrl;responseFactory=new ResponseFactory;interceptors=[];errorInterceptors=[new abstractHttpClient.NetworkErrorInterceptor];constructor(baseUrl=void 0,axiosAdapter=axios.defaults.adapter,axiosConfig={withCredentials:!0}){this.baseUrl=baseUrl,this.http=axios.create({baseURL:baseUrl,adapter:axiosAdapter,...axiosConfig})}async get(url,headers={},options){return this.send(this.request(abstractHttpClient.HttpMethods.GET,url,null,headers,options))}async post(url,data=null,headers={},options){return this.send(this.request(abstractHttpClient.HttpMethods.POST,url,data,headers,options))}async put(url,data=null,headers={},options){return this.send(this.request(abstractHttpClient.HttpMethods.PUT,url,data,headers,options))}async delete(url,headers={},options){return this.send(this.request(abstractHttpClient.HttpMethods.DELETE,url,null,headers,options))}async patch(url,data=null,headers={},options){return this.send(this.request(abstractHttpClient.HttpMethods.PATCH,url,data,headers,options))}async head(url,headers={},options){return this.send(this.request(abstractHttpClient.HttpMethods.HEAD,url,null,headers,options))}request(method,url,body=null,headers={},options){return new abstractHttpClient.HttpRequest(method,url,body,headers,options)}async send(request){try{await this.interceptRequest(request);const axiosResponse=await this.http.request({url:request.url,data:request.body,method:request.method,headers:request.headers,baseURL:this.baseUrl,onUploadProgress:this.progressHandler(request.options.onUploadProgress),responseType:this.responseBodyConversionToResponseType(request.options.responseBodyConversion)}),response=this.responseFactory.create(axiosResponse,request);return await this.interceptResponse(response),response}catch(e){throw this.handleError(e,request)}}progressHandler(onProgress){if(onProgress)return progressEvent=>{const percent=Math.min(100*progressEvent.loaded/progressEvent.total,100);onProgress(percent)}}async interceptRequest(request){for(let interceptor of this.interceptors)interceptor.onRequest&&await interceptor.onRequest(request)}async interceptResponse(response){for(let interceptor of this.interceptors)interceptor.onResponse&&await interceptor.onResponse(response)}addInterceptor(interceptor){this.interceptors.push(interceptor),interceptor.onError&&this.errorInterceptors.push(interceptor)}handleError(e,request){let error=this.createHttpError(e,request,this.baseUrl);for(let interceptor of this.errorInterceptors)error=interceptor.onError(error,request);return error}createHttpError(error,request,baseUrl){if(["ECONNREFUSED","ERR_NETWORK"].includes(error.code))return this.createNetworkError(error,request,baseUrl);const urlHelper=new abstractHttpClient.UrlHelper(baseUrl,request.url),response={method:request.method,status:error.response?.status??0,statusText:error.response?.statusText??"",url:urlHelper.absoluteUrl,headers:error.response?.headers??{},body:error.response?.data,request:request};return new abstractHttpClient.HttpError(request,response,error)}createNetworkError(error,request,baseUrl){const urlHelper=new abstractHttpClient.UrlHelper(baseUrl,request.url),response={method:request.method,status:0,statusText:error.code,url:urlHelper.absoluteUrl,headers:error.response?.headers??{},body:error.response?.data,request:request};return new abstractHttpClient.NetworkError(request,response,error)}responseBodyConversionToResponseType(responseBodyConversion){switch(responseBodyConversion){case abstractHttpClient.ResponseBodyConversions.Json:return"json";case abstractHttpClient.ResponseBodyConversions.Stream:return"stream";case abstractHttpClient.ResponseBodyConversions.ArrayBuffer:return"arraybuffer";default:throw new Error(`Unsupported response body conversion: ${responseBodyConversion}`)}}};
//# sourceMappingURL=index.js.map
